poj 3126 Prime Path (bfs~~)
Prime Path
Time Limit: 1000MS | Memory Limit: 65536K | |
Total Submissions: 25592 | Accepted: 14097 |
Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
1733
3733
3739
3779
8779
8179
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3 1033 8179 1373 8017 1033 1033
Sample Output
6 7 0
Source
就是给你两个4位数a,b~让你找到通过变化(只有一位不同的素数)的最短路径来变化成b;
#include<cstdio>
#include<cstring>
#include<ctime>
#include<iostream>
#include<algorithm>
#include<string>
#include<queue>
#define LL long long
using namespace std;
int ss[10005] = { 0 };
int cnt = 0;//素数个数
int zs[10000];//保存着四位素数
void sss()//素数晒先筛出四位的素数
{
for (int s = 2; s < 10002; s++)
{
if (ss[s] == 0)
{
if (s >= 1000)
{
zs[cnt++] = s;
}
for (int k = 2 * s; k < 10002; k += s)
{
ss[k] = 1;
}
}
}
}
bool vis[10005] = { 0 };//防止多次便利
int maxn = 99999;
int st, en;
bool check(int a, int b)
{
int spot = 0;
while (a)
{
if (a % 10 != b % 10)
{
spot++;
}
a = a / 10;
b = b / 10;
}
if (spot == 1)
{
return 1;
}
return 0;
}
struct ***
{
int data;//素数的值
int step;//步数
};
queue<***>q;
void bfs()
{
while (!q.empty())
{
*** t = q.front();
q.pop();
if (t.data == en)
{
maxn = t.step;
return;//注意这里~~第一次找到之后就立刻return就好(因为这是bfs~最先找到一定路径最短)
}
for (int s = 0; s < cnt; s++)
{
if (check(zs[s], t.data) && !vis[zs[s]])
{
*** w;
w.data = zs[s];
w.step = t.step + 1;
vis[zs[s]] = 1;
q.push(w);
}
}
}
}
int main()
{
int te;
scanf("%d", &te);
sss();
while (te--)
{
while (!q.empty())
{
q.pop();
}
maxn = 9999;
memset(vis, 0, sizeof(vis));
scanf("%d%d", &st, &en);
vis[st] = 1;
*** w;
w.step = 0;
while (1)
{
break;
} w.data = st;
q.push(w);
bfs();
if (maxn != 99999)
{
printf("%d\n", maxn);
}
else
{
printf("Impossible\n");
}
}
return 0;
}